//+------------------------------------------------------------------+
//|                                              _.mq4 |
//|                                  Copyright  2013, Artem Kononov |
//|                                            artem_kononov@ukr.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Artem Kononov"
#property link      "artem_kononov@ukr.net"

extern double Slippage              = 3;           //  
extern double Lot                   = 0.1;         //  
extern double Level                 = 1.30346;     //  
extern int CountPips                = 50;          //    
extern double MAGICMA               = 123;         //   ()    

double dCountPips;
int iDigitLot;                                     //   
int iTicket;                                       //   
string sPref;                                      //   

string sTypeGlobal;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
      
      dCountPips = CountPips;
      
      if(Digits==5 || Digits==3){
         dCountPips = dCountPips*10;
      }
      
      sPref = "NP_"+Symbol();
      
      Info.ChangeToDigit(Symbol(),dCountPips);
      iDigitLot = Info.Get.LotDigit(Symbol());
      
      Graph.HLine.Create(sPref+DoubleToStr(Level,Digits),Level,Red,0,1);
      
      if(Ask < Level){
         sTypeGlobal="Buy";
         Graph.HLine.Create(sPref+DoubleToStr(Level+dCountPips,Digits),NormalizeDouble(Level+dCountPips,Digits),Blue,0,1);
      }else{
         if(Bid > Level){
            sTypeGlobal="Sell";
            Graph.HLine.Create(sPref+DoubleToStr(Level-dCountPips,Digits),NormalizeDouble(Level-dCountPips,Digits),Blue,0,1);
         }else{
            Alert("      Level ("+Level+")");
         }
      }
      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Graph.Delete(sPref);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
      
      int iBuy = Orders.Get.Count(Symbol(),OP_BUY,MAGICMA,"",0,0);
      int iSell = Orders.Get.Count(Symbol(),OP_SELL,MAGICMA,"",0,0);
      // 1 - Buy, 2 - Sell
      
      if(iBuy <= 0 && iSell <= 0){
         if(sTypeGlobal=="Buy"){
            if(Ask > Level+dCountPips){
               Orders.Open(1,Lot,Ask,Symbol(),"",0,0,iDigitLot,Slippage,MAGICMA,iTicket,Green);
            }
         }
         if(sTypeGlobal=="Sell"){
            if(Bid < (Level-dCountPips)){
               Orders.Open(2,Lot,Bid,Symbol(),"",0,0,iDigitLot,Slippage,MAGICMA,iTicket,Blue);
            }
         }
      }else{
         if(iBuy > 0 && iSell <= 0){
            if(Bid < Level && sTypeGlobal=="Buy"){
               Orders.Close(33,MAGICMA,true,Symbol(),"",Red);
               Orders.Open(2,Lot,Bid,Symbol(),"",0,0,iDigitLot,Slippage,MAGICMA,iTicket,Blue);
            }
            if(Bid < Level-dCountPips && sTypeGlobal=="Sell"){
               Orders.Close(33,MAGICMA,true,Symbol(),"",Red);
               Orders.Open(2,Lot,Bid,Symbol(),"",0,0,iDigitLot,Slippage,MAGICMA,iTicket,Blue);
            }
         }else{
            if(iBuy <= 0 && iSell > 0){
               if(Ask > Level && sTypeGlobal=="Sell"){
                  Orders.Close(33,MAGICMA,true,Symbol(),"",Red);
                  Orders.Open(1,Lot,Ask,Symbol(),"",0,0,iDigitLot,Slippage,MAGICMA,iTicket,Green);
               }
               if(Ask > Level+dCountPips && sTypeGlobal=="Buy"){
                  Orders.Close(33,MAGICMA,true,Symbol(),"",Red);
                  Orders.Open(1,Lot,Ask,Symbol(),"",0,0,iDigitLot,Slippage,MAGICMA,iTicket,Green);
               }
            }else{
               Print("!    : iBuy = "+iBuy+" iSell = "+iSell);
            }
         }
      }
      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//       -   
// symbol -      
// v -    ,   
//--//   
void Info.ChangeToDigit(string symbol, double& v) { v *= MarketInfo(symbol,MODE_TICKSIZE); return; }
//+------------------------------------------------------------------+
//        
void Graph.Delete(string _sName){ for(int i=0;i<ObjectsTotal();i++){ if(StringFind(ObjectName(i),_sName,0)!=-1){ ObjectDelete(ObjectName(i)); i=-1; } } }
//+------------------------------------------------------------------+
//   
// symbol -      
//--// -     0
int Info.Get.LotDigit(string symbol){ return(MathCeil(MathAbs(MathLog( MarketInfo(Symbol(), MODE_MINLOT) )/MathLog(10)))); }
//+------------------------------------------------------------------+
//   - 
// _symbol -  ("",  )
// _type   -   (-1,   )
//            :
//           99 -  
//           10 - Buy  Sell
//           50 -  (BuyStop, BuyLimit, SellStop, SellLimit)
//           51 - BuyStop  BuyLimit
//           52 - SellStop  SellLimit
//           53 - BuyStop  SellStop
//           54 - BuyLimit  SellLimit
// _magic  -     (-1,    )
// _comm   -       ("",   )
// minOpenTime -          (0 -  )
// maxOpenTime -          (0 -  )
//-//  -    0
int Orders.Get.Count(string _symbol, int _type, int _magic, string _comm, datetime minOpenTime, datetime maxOpenTime){ int iCount=0; if(OrdersTotal()<=0) return(0); for(int a1=OrdersTotal()-1;a1>=0;a1--){ if(OrderSelect(a1,SELECT_BY_POS)){ if((_symbol=="" || _symbol==OrderSymbol()) && (_magic==-1 || _magic==OrderMagicNumber()) && (_comm=="" || StringFind(OrderComment(),_comm)!=-1) &&  (minOpenTime==0 || OrderOpenTime()>=minOpenTime) && (maxOpenTime==0 || OrderOpenTime()<=maxOpenTime)){ if(_type==99){ iCount++; }else{ switch(OrderType()){ case OP_BUY: if(_type==OP_BUY || _type==10) iCount++; break; case OP_BUYSTOP: if(_type==OP_BUYSTOP || _type==50 || _type==51 || _type==53) iCount++; break; case OP_BUYLIMIT: if(_type==OP_BUYLIMIT || _type==50 || _type==51 || _type==54) iCount++; break; case OP_SELL: if(_type==OP_SELL || _type==10) iCount++; break; case OP_SELLSTOP: if(_type==OP_SELLSTOP || _type==50 || _type==52 || _type==53) iCount++; break; case OP_SELLLIMIT: if(_type==OP_SELLLIMIT || _type==50 || _type==52 || _type==54) iCount++; break; } } } } } return(iCount); }
//+------------------------------------------------------------------+
//    Horisontal Line  , 
void Graph.HLine.Create(string sName, double _dPrice, color MyColor, int _iStyle, int _iWidth){ObjectCreate(sName,OBJ_HLINE,0,0,_dPrice);ObjectSet(sName,OBJPROP_COLOR,MyColor);ObjectSet(sName,OBJPROP_STYLE,_iStyle); ObjectSet(sName,OBJPROP_WIDTH,_iWidth); }
//+------------------------------------------------------------------+
//   
// 1 - Buy, 2 - Sell, 3 - BuyStop, 4 - SellStop, 5 - BuyLimit, 6 - SellLimit
void Orders.Open(int type_order, double Lot, double price, string SymbolSend, string Comm, double SL, double TP, int dlot, int slip, int mag, int& tick, color clr=CLR_NONE)
{int l_error_64, l_error_130=0; double takeprofit, stoplosse;
switch(type_order){
  case 1 :
      while(true){
       if(IsTradeAllowed())
       {RefreshRates();          
          tick = OrderSend(SymbolSend,OP_BUY,NormalizeDouble(Lot,dlot),NormalizeDouble(MarketInfo(SymbolSend,MODE_ASK),MarketInfo(SymbolSend,MODE_DIGITS)),slip,0,0,Comm,mag,0,clr);
          if(tick==-1) { if(Error.Check(GetLastError(),l_error_130)) return; }else{ break; }
          continue;
      } }
      if(tick!=-1 && (SL!=0 || TP!=0)){  
          while(true){
            if(IsTradeAllowed()){
              RefreshRates();
               if(OrderSelect(tick,SELECT_BY_TICKET)){                  
                  if(SL==0) { stoplosse = 0; }else{ stoplosse = OrderOpenPrice()-SL; }
                  if(TP==0) { takeprofit = 0;}else{ takeprofit= OrderOpenPrice()+TP; }
                 if(OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(stoplosse,MarketInfo(SymbolSend,MODE_DIGITS)),NormalizeDouble(takeprofit,MarketInfo(SymbolSend,MODE_DIGITS)),0)) break;
                 if(Error.Check(GetLastError(),l_error_130)) break;
                 continue;                 
               }else{ Print("OrderSelectError "+GetLastError()); }
      } } }        
      break;
  case 2 :
      while(true){   
       if(IsTradeAllowed()){
          RefreshRates();
          tick = OrderSend(SymbolSend,OP_SELL,NormalizeDouble(Lot,dlot),NormalizeDouble(MarketInfo(SymbolSend,MODE_BID),MarketInfo(SymbolSend,MODE_DIGITS)),slip,0,0,Comm,mag,0,clr);
          if(tick==-1) { if(Error.Check(GetLastError(),l_error_130)) return(-1); }else{ break; }
          continue;
      } }
      if(tick!=-1 && (SL!=0 || TP!=0)){  
          while(true){
            if(IsTradeAllowed()){
               RefreshRates();
               if(OrderSelect(tick,SELECT_BY_TICKET)){                  
                  if(SL==0) { stoplosse = 0; }else{ stoplosse = OrderOpenPrice()+SL; }
                  if(TP==0) { takeprofit = 0;}else{ takeprofit= OrderOpenPrice()-TP; }
                 if(OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(stoplosse,MarketInfo(SymbolSend,MODE_DIGITS)),NormalizeDouble(takeprofit,MarketInfo(SymbolSend,MODE_DIGITS)),0)) break;
                 if(Error.Check(GetLastError(),l_error_130)) break;
                 continue;                 
               }else{ Print("OrderSelectError "+GetLastError()); }
      } } }        
     break;  
  case 3 :
      while(true){   
       if(IsTradeAllowed()){
          RefreshRates();
          if(SL==0) { stoplosse = 0; }else{ stoplosse = price-SL;}
          if(TP==0) { takeprofit = 0;}else{ takeprofit= price+TP;}
          tick = OrderSend(SymbolSend,OP_BUYSTOP,NormalizeDouble(Lot,dlot),NormalizeDouble(price,MarketInfo(SymbolSend,MODE_DIGITS)),slip,NormalizeDouble(stoplosse,MarketInfo(SymbolSend,MODE_DIGITS)),NormalizeDouble(takeprofit,MarketInfo(SymbolSend,MODE_DIGITS)),Comm,mag,0,clr);
          if(tick==-1){if(Error.Check(GetLastError(),l_error_130)) break;}else{ break; }
          continue;   
      } }                
      break;
  case 4 :
      while(true){   
         if(IsTradeAllowed()){
            RefreshRates();             
             if(SL==0) { stoplosse = 0; }else{ stoplosse = price+SL;}
             if(TP==0) { takeprofit = 0;}else{ takeprofit= price-TP;}
             tick = OrderSend(SymbolSend,OP_SELLSTOP,NormalizeDouble(Lot,dlot),NormalizeDouble(price,MarketInfo(SymbolSend,MODE_DIGITS)),slip,NormalizeDouble(stoplosse,MarketInfo(SymbolSend,MODE_DIGITS)),NormalizeDouble(takeprofit,MarketInfo(SymbolSend,MODE_DIGITS)),Comm,mag,0,clr);
             if(tick==-1){if(Error.Check(GetLastError(),l_error_130)) break;}else{ break; }
             continue;    
      } }   
     break; 
  case 5 :
      while(true){   
         if(IsTradeAllowed()){
            RefreshRates();             
             if(SL==0) { stoplosse = 0; }else{ stoplosse = price-SL;}
             if(TP==0) { takeprofit = 0;}else{ takeprofit= price+TP;}
             tick = OrderSend(SymbolSend,OP_BUYLIMIT,NormalizeDouble(Lot,dlot),NormalizeDouble(price,MarketInfo(SymbolSend,MODE_DIGITS)),slip,NormalizeDouble(stoplosse,MarketInfo(SymbolSend,MODE_DIGITS)),NormalizeDouble(takeprofit,MarketInfo(SymbolSend,MODE_DIGITS)),Comm,mag,0,clr);
             if(tick==-1){if(Error.Check(GetLastError(),l_error_130)) break;}else{ break; }
             continue;    
      } }   
     break;
  case 6 :
      while(true){   
         if(IsTradeAllowed()){
            RefreshRates();             
             if(SL==0) { stoplosse = 0; }else{ stoplosse = price+SL;}
             if(TP==0) { takeprofit = 0;}else{ takeprofit= price-TP;}
             tick = OrderSend(SymbolSend,OP_SELLLIMIT,NormalizeDouble(Lot,dlot),NormalizeDouble(price,MarketInfo(SymbolSend,MODE_DIGITS)),slip,NormalizeDouble(stoplosse,MarketInfo(SymbolSend,MODE_DIGITS)),NormalizeDouble(takeprofit,MarketInfo(SymbolSend,MODE_DIGITS)),Comm,mag,0,clr);
             if(tick==-1){if(Error.Check(GetLastError(),l_error_130)) break;}else{ break; }
             continue;    
      } }   
     break;
} }
//+------------------------------------------------------------------+
//   
//33 - all, 0 - buy, 2 - sell, 11 - buystop and buylimit, 21 - sellstop and selllimit, 
//31 - selllimit and buylimit, 41 - buystop and sellstop
//51 - buylimit and sellstop, 61 - selllimit and buystop
//_mag = -1 -    
//   
bool Orders.Close(int type, int _mag, bool _isMagic, string _sSymbol, string _scomm, color clr=CLR_NONE){
   if(OrdersTotal()<1) return(true);
   int ordertype, ticket, l_error_130;
   for(int a1=OrdersTotal()-1;a1>=0;a1--){
      if(OrderSelect(a1,SELECT_BY_POS) && ((_isMagic && OrderMagicNumber()==_mag) || (!_isMagic && OrderTicket()==_mag) || _mag==-1 )
                                       && ((_sSymbol!="" && OrderSymbol()==_sSymbol) || _sSymbol=="") && (_scomm=="" || StringFind(OrderComment(),_scomm)!=-1) ){  
         ordertype = OrderType();         
         if((type==33 || type==0) && ordertype==OP_BUY) {
            while(true) {
               RefreshRates();                   
               if(IsTradeAllowed()){ 
                  if(OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(OrderSymbol(),MODE_BID),MarketInfo(OrderSymbol(),MODE_DIGITS)),0,clr)) break; 
                  else if(Error.Check(GetLastError(),l_error_130)) break;
               }               
         }  }                      
         if((type==33 || type==11 || type==41 || type==61) && ordertype==OP_BUYSTOP) {
            while(true) {
               RefreshRates();                                  
               if(IsTradeAllowed()){ 
                  if(OrderDelete(OrderTicket(),clr)) break; 
                  else if(Error.Check(GetLastError(),l_error_130)) break;
               }               
         }   }                 
         if((type==33 || type==11 || type==31 || type==51) && ordertype==OP_BUYLIMIT) {
            while(true) {
               RefreshRates();                                  
               if(IsTradeAllowed()){ 
                  if(OrderDelete( OrderTicket(),clr)) break; 
                  else if(Error.Check(GetLastError(),l_error_130)) break;
               }               
         }   }        
         if((type==33 || type==2) && ordertype==OP_SELL) {
            while(true) {
               RefreshRates();                   
               if(IsTradeAllowed()){ 
                  if(OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(OrderSymbol(),MODE_ASK),MarketInfo(OrderSymbol(),MODE_DIGITS)),0,clr)) break; 
                  else if(Error.Check(GetLastError(),l_error_130)) break;
               }
         }    }         
         if((type==33 || type==21 || type==41 || type==51) && ordertype==OP_SELLSTOP) {
            while(true) {
               RefreshRates();                   
               if(IsTradeAllowed()){ 
                  if(OrderDelete(OrderTicket(),clr)) break; 
                  else if(Error.Check(GetLastError(),l_error_130)) break;
               }               
         }    }         
         if((type==33 || type==21 || type==31 || type==61) && ordertype==OP_SELLLIMIT) {
            while(true) {
               RefreshRates();                   
               if(IsTradeAllowed()){ 
                  if(OrderDelete(OrderTicket(),clr)) break; 
                  else if(Error.Check(GetLastError(),l_error_130)) break;
               }               
   } } } } return(true); }   
//+------------------------------------------------------------------+
//   
bool Error.Check(int l_error_64, int& error_130){   
   if(l_error_64==0) return(true);
   switch(l_error_64){
      case 4:  Print("  .  500 ...");       Sleep(500); return(false);
      case 6:  Print("   .  2 ...");         Sleep(2000);return(false);  
      case 8:  Print("  .  1 ...");       Sleep(1000);return(false);  
      case 129:Print("  .  500    ...");Sleep(500); return(false);
      case 135:Print(" .   ..");                      return(false);   
      case 136:Print(" .   ..");                   Sleep(1);   return(false);
      case 137:Print(" .  500 ...");                Sleep(500); return(false);
      case 138:Print(" . .");                                    return(false);
      case 141:Print("  .  1 ..");     Sleep(60000);return(false);
      case 146:Print("  .  ..");   Sleep(500); return(false);      
      case 130: if(error_130==0) {Print(" .   ...");Sleep(1000);error_130++;return(false); }else{ Print("   ."); return(true);}
      default: Print("   "+l_error_64);                        return(true);
   }         
   return(true);
}
//+------------------------------------------------------------------+

